import ij.measure.ResultsTable as ResultsTable
import ij.plugin.frame.RoiManager as RoiManager
import ij.plugin.filter.ParticleAnalyzer as ParticleAnalyzer
import ij.measure.Measurements as Measurements
from java.lang import Double
import math


def ParticleAnal(imp,ThrDiam, dXpixNorm):
    table1 = ResultsTable() # ELLIPSES
# Create a hidden ROI manager, to store a ROI for each blob or cell
    roim = RoiManager(True)
    pa = ParticleAnalyzer(ParticleAnalyzer.SHOW_OVERLAY_MASKS,Measurements.ELLIPSE+Measurements.AREA, table1, 0, Double.POSITIVE_INFINITY, 0.0, 1.0)
    #pa = ParticleAnalyzer(ParticleAnalyzer.ADD_TO_MANAGER+ParticleAnalyzer.SHOW_MASKS,Measurements.ELLIPSE, table1, 0, Double.POSITIVE_INFINITY, 0.0, 1.0)
    pa.setHideOutputImage(True)
# The measured areas are listed in the first column of the results table, as a float array:
    pa.analyze(imp)
    #mask = pa.getOutputImage() 
    
# ELLIPSE PARAMETERS + AREAS
    a = table1.getColumn(table1.getColumnIndex('Major'))   # major axis of fitted ellipse
    b = table1.getColumn(table1.getColumnIndex('Minor'))   # minor axis of fitted ellipse
    angle = table1.getColumn(table1.getColumnIndex('Angle'))   # angle of major axis measured to x axis
    areas = table1.getColumn(table1.getColumnIndex('Area'))   # areas of islets
  
    # THRESHOLDING OF SMALL OBJECTS
    #ThrDiam = 20
    NrPixThr = math.pi*math.pow(0.5*ThrDiam/dXpixNorm,2)   # pixel Area for given circular diameter 
    Thr = NrPixThr    # number of pixels contained in objects, threshold
    areasThr = []
    aThr = []
    bThr = []
    angleThr = []
    
    for ar in areas:
        if ar > Thr:
            areasThr.append(ar)

    for ind in range(0,len(areas)):
        if areas[ind] > Thr:
            aThr.append(a[ind])
            bThr.append(b[ind])
            angleThr.append(angle[ind])
    areas = areasThr
    a = aThr
    b = bThr
    angle = angleThr
    return areas, a, b, angle
